image: node:12.18.1

workflow:
    rules:
        - if: '$DO_DEPLOY == "true"'

stages:
    - build
    - test
    - deploy

build_frontend:
    stage: build
    rules:
        - if: '$PROJECT == "frontend" && $CI_COMMIT_BRANCH =~ /^release\/[a-zA-Z0-9]+/'
        - if: '$PROJECT == "frontend" && $CI_COMMIT_BRANCH =~ /^hotfix\/[a-zA-Z0-9]+/'
        - if: '$PROJECT == "frontend" && $CI_COMMIT_BRANCH == "master"'
    script:
        - cd client && npm install && npm run build

test_frontend:
    stage: test
    rules:
        - if: '$PROJECT == "frontend" && $CI_COMMIT_BRANCH =~ /^release\/[a-zA-Z0-9]+/'
        - if: '$PROJECT == "frontend" && $CI_COMMIT_BRANCH =~ /^hotfix\/[a-zA-Z0-9]+/'
        - if: '$PROJECT == "frontend" && $CI_COMMIT_BRANCH == "master"'
    script:
        - CI=true npm run test:client

test_backend:
    stage: test
    rules:
        - if: '$PROJECT == "backend" && $CI_COMMIT_BRANCH =~ /^release\/[a-zA-Z0-9]+/'
        - if: '$PROJECT == "backend" && $CI_COMMIT_BRANCH =~ /^hotfix\/[a-zA-Z0-9]+/'
        - if: '$PROJECT == "backend" && $CI_COMMIT_BRANCH == "master"'
    script:
        - npm install
        - CI=true npm run test:server

deploy_staging:
    stage: deploy
    rules:
        - if: $CI_COMMIT_BRANCH =~ /^release\/[a-zA-Z0-9]+/ || $CI_COMMIT_BRANCH =~ /^hotfix\/[a-zA-Z0-9]+/
    image: docker:19.03.12
    services:
        - docker:19.03.12-dind   
    script:
        - docker login -u _ -p $HEROKU_API_KEY $HEROKU_REGISTRY
        - docker build --rm=true -t $HEROKU_STAGING_REGISTRY_IMAGE .
        - docker push $HEROKU_STAGING_REGISTRY_IMAGE
        - docker run -e HEROKU_API_KEY=$HEROKU_API_KEY wingrunr21/alpine-heroku-cli:latest container:release web -a $HEROKU_STAGING_APP_NAME

deploy_production:
    stage: deploy
    rules:
        - if: '$CI_COMMIT_BRANCH == "master"'
    image: docker:19.03.12
    services:
        - docker:19.03.12-dind   
    script:
        - docker login -u _ -p $HEROKU_API_KEY $HEROKU_REGISTRY
        - docker build --rm=true -t $HEROKU_PRODUCTION_REGISTRY_IMAGE .
        - docker push $HEROKU_PRODUCTION_REGISTRY_IMAGE
        - docker run -e HEROKU_API_KEY=$HEROKU_API_KEY wingrunr21/alpine-heroku-cli:latest container:release web -a $HEROKU_PRODUCTION_APP_NAME
